DECLARE FUNCTION COMGETTIMEOUT% (COMBIO%(), COMV%(), PORT%)
DECLARE FUNCTION COMRXON% (COMBIO%(), COMV%(), PORT%)
DECLARE FUNCTION COMSETTIMEOUT% (COMBIO%(), COMV%(), PORT%, TIMEOUT%)
DECLARE FUNCTION COMRXOFF% (COMBIO%(), COMV%(), PORT%)
DECLARE FUNCTION COMDETECTPORT% (COMBIO%(), COMV%(), PORT%)
DECLARE FUNCTION COMGETPORTS% (COMBIO%(), COMV%(), PORT%)
DECLARE FUNCTION COMGETMCR% (COMBIO%(), COMV%(), PORT%)
DECLARE FUNCTION COMGETFC% (COMBIO%(), COMV%(), PORT%)
DECLARE FUNCTION COMGETPARAM% (COMBIO%(), COMV%(), PORT%)
DECLARE FUNCTION COMGETINFO% (COMBIO%(), COMV%(), PORT%, BAUD%, DB%, PARITY%, SB%)
DECLARE FUNCTION COMRXS% (COMBIO%(), COMV%(), PORT%, STRA$)
DECLARE FUNCTION COMBREAK% (COMBIO%(), COMV%(), PORT%, BRK%)
DECLARE FUNCTION COMTXS% (COMBIO%(), COMV%(), PORT%, STRA$)
DECLARE FUNCTION COMSETFLOW% (COMBIO%(), COMV%(), PORT%, FLOW%)
DECLARE FUNCTION COMPEEK% (COMBIO%(), COMV%(), PORT%)
DECLARE FUNCTION COMPURGERXBUF% (COMBIO%(), COMV%(), PORT%)
DECLARE FUNCTION COMSETDTR% (COMBIO%(), COMV%(), PORT%)
DECLARE FUNCTION COMACTIVE% (COMBIO%(), COMV%(), PORT%)
DECLARE FUNCTION COMINIT% (COMBIO%(), COMV%(), PORT%, BAUD%, DB%, PARITY%, SB%)
DECLARE FUNCTION COMTXCH% (COMBIO%(), COMV%(), PORT%, CH%)
DECLARE FUNCTION COMRXCH% (COMBIO%(), COMV%(), PORT%, CH%)
DECLARE FUNCTION COMSTAT% (COMBIO%(), COMV%(), PORT%)
DECLARE FUNCTION COMBUFSTAT% (COMBIO%(), COMV%(), PORT%)
DECLARE FUNCTION COMSETPORT% (COMBIO%(), COMV%(), PORT%, ADDR%)
DECLARE FUNCTION COMSETVECTOR% (COMBIO%(), COMV%(), PORT%, ADDR%)
DECLARE FUNCTION COMSETACTIVE% (COMBIO%(), COMV%(), PORT%, ACTIVE%)
DECLARE FUNCTION COMSETMCR% (COMBIO%(), COMV%(), PORT%, MCR%)
DECLARE SUB COMINITIAL (COMBIO%(), COMV%())


REM COMBIO% IS AN INTERFACE BETWEEN BASIC PROGRAM AND PCCOM DRIVER
REM COMV% IS PARAMETERS BETREEN BASIC PROGRAM AND PCCOM DRIVER

DIM COMBIO%(32)
DIM COMV%(4)

REM FIRST OF ALL, COMINITIAL MUST BE CALLED IMEDIATELY

CALL COMINITIAL(COMBIO%(), COMV%())


REM CALL PCCOM DRIVER TO INITIAL ADAPTER

R% = COMSETVECTOR(COMBIO%(), COMV%(), 4, &HD400)
PRINT R%

FOR I% = 4 TO 11
  IF (I% <= 7) THEN
    R1% = COMSETPORT(COMBIO%(), COMV%(), I%, &HD400)
  ELSE
    R1% = COMSETPORT(COMBIO%(), COMV%(), I%, &HD440)
  END IF
  R2% = COMINIT(COMBIO%(), COMV%(), I%, 19200, 8, 0, 1)
  PRINT R1%, R2%
NEXT I%

R% = COMGETINFO(COMBIO%(), COMV%(), 4, BAUD%, DB%, PARITY%, SB%)
PRINT "COM STATUS -- BAUD"; BAUD%; "DATA BITS"; DB%; "PARITY"; PARITY%; "STOP BIT"; SB%

REM THIS IS AN EXAMPLE WHICH TRANSMITS A STRING WITH 10 TIMES

A$ = "PCCOM TEST PROGRAM FOR BASIC" + CHR$(13) + CHR$(10)

PRINT "Begin To Send Data"
FOR I% = 1 TO 5
  R% = COMTXS(COMBIO%(), COMV%(), 4, A$)
  PRINT USING "##"; R%;
NEXT I%

PRINT
C% = COMPEEK(COMBIO%(), COMV%(), 4)
PRINT "Peek Data :"; CHR$(C%)

PRINT
REM LOOP UNTIL RECEIVED ALL DATA IN RECEIVED BUFFER

PRINT "Begin To Receive Data"

R% = COMRXS(COMBIO%(), COMV%(), 4, B$)
PRINT R%, B$

PRINT
DATAIN% = COMBUFSTAT(COMBIO%(), COMV%(), 4)
PRINT "Received"; DATAIN%; "characters"

FOR I% = 1 TO DATAIN%
  R% = COMRXCH(COMBIO%(), COMV%(), 4, C%)
IF (R% = 0) THEN PRINT CHR$(C%);
NEXT I%

FUNCTION COMACTIVE% (COMBIO%(), COMV%(), PORT%)

COMV%(0) = &H4 * 256
COMV%(1) = 0
COMV%(2) = 0
COMV%(3) = PORT%

DEF SEG = VARSEG(COMBIO%(0))
CALL ABSOLUTE(VARPTR(COMBIO%(0)))
DEF SEG

COMACTIVE% = COMV%(0)

END FUNCTION

FUNCTION COMBREAK% (COMBIO%(), COMV%(), PORT%, BRK%)

COMV%(0) = &H1A * 256 + BRK%
COMV%(1) = 0
COMV%(2) = 0
COMV%(3) = PORT%

DEF SEG = VARSEG(COMBIO%(0))
CALL ABSOLUTE(VARPTR(COMBIO%(0)))
DEF SEG

COMBREAK% = 0

END FUNCTION

FUNCTION COMBUFSTAT% (COMBIO%(), COMV%(), PORT%)

COMV%(0) = &H30 * 256
COMV%(1) = 0
COMV%(2) = 0
COMV%(3) = PORT%

DEF SEG = VARSEG(COMBIO%(0))
CALL ABSOLUTE(VARPTR(COMBIO%(0)))
DEF SEG

COMBUFSTAT% = COMV%(2)

END FUNCTION

FUNCTION COMDETECTPORT% (COMBIO%(), COMV%(), PORT%)

COMV%(0) = &H3B * 256
COMV%(1) = 0
COMV%(2) = 0
COMV%(3) = PORT%

DEF SEG = VARSEG(COMBIO%(0))
CALL ABSOLUTE(VARPTR(COMBIO%(0)))
DEF SEG

IF COMV%(0) = &H55AA THEN
   COMDETECTPORT% = 1
ELSE
   COMDETECTPORT% = 0
END IF

END FUNCTION

FUNCTION COMGETFC% (COMBIO%(), COMV%(), PORT%)

COMV%(0) = &H37 * 256
COMV%(1) = 0
COMV%(2) = 0
COMV%(3) = PORT%

DEF SEG = VARSEG(COMBIO%(0))
CALL ABSOLUTE(VARPTR(COMBIO%(0)))
DEF SEG

COMGETFC% = COMV%(0) MOD 256

END FUNCTION

FUNCTION COMGETINFO% (COMBIO%(), COMV%(), PORT%, BAUD%, DB%, PARITY%, SB%)

R% = COMGETPARAM(COMBIO%(), COMV%(), PORT%)
N% = (R% / 32) AND 7
IF N% = 0 THEN
  BAUD% = 19200
ELSEIF N% = 1 THEN
  BAUD% = 38400
ELSEIF N% = 2 THEN
  BAUD% = 300
ELSEIF N% = 3 THEN
  BAUD% = 600
ELSEIF N% = 4 THEN
  BAUD% = 1200
ELSEIF N% = 5 THEN
  BAUD% = 2400
ELSEIF N% = 6 THEN
  BAUD% = 4800
ELSEIF N% = 7 THEN
  BAUD% = 9600
END IF

N% = (R% / 8) AND 3
IF N% = 1 THEN
  PARITY% = 1
ELSEIF N% = 3 THEN
  PARITY% = 2
ELSE
  PARITY% = 0
END IF

N% = (R% / 4) AND 1
SB% = 2 - N%

N% = R% AND 3
IF N% = 0 THEN
  DB% = 5
ELSEIF N% = 1 THEN
  DB% = 6
ELSEIF N% = 2 THEN
  DB% = 7
ELSE
  DB% = 8
END IF

COMGETINFO% = 0

END FUNCTION

FUNCTION COMGETMCR% (COMBIO%(), COMV%(), PORT%)

COMV%(0) = &H36 * 256
COMV%(1) = 0
COMV%(2) = 0
COMV%(3) = PORT%

DEF SEG = VARSEG(COMBIO%(0))
CALL ABSOLUTE(VARPTR(COMBIO%(0)))
DEF SEG

COMGETMCR% = COMV%(0) MOD 256

END FUNCTION

FUNCTION COMGETPARAM% (COMBIO%(), COMV%(), PORT%)

COMV%(0) = &H35 * 256
COMV%(1) = 0
COMV%(2) = 0
COMV%(3) = PORT%

DEF SEG = VARSEG(COMBIO%(0))
CALL ABSOLUTE(VARPTR(COMBIO%(0)))
DEF SEG

COMGETPARAM% = COMV%(0) MOD 256

END FUNCTION

FUNCTION COMGETPORTS% (COMBIO%(), COMV%(), PORT%)

COMV%(0) = &H3A * 256
COMV%(1) = 0
COMV%(2) = 0
COMV%(3) = PORT%

DEF SEG = VARSEG(COMBIO%(0))
CALL ABSOLUTE(VARPTR(COMBIO%(0)))
DEF SEG

COMGETPORTS% = COMV%(0)

END FUNCTION

FUNCTION COMGETTIMEOUT% (COMBIO%(), COMV%(), PORT%)

COMV%(0) = &H40 * 256
COMV%(1) = 0
COMV%(2) = 0
COMV%(3) = PORT%

DEF SEG = VARSEG(COMBIO%(0))
CALL ABSOLUTE(VARPTR(COMBIO%(0)))
DEF SEG

COMGETTIMEOUT% = COMV%(3)

END FUNCTION

FUNCTION COMINIT% (COMBIO%(), COMV%(), PORT%, BAUD%, DB%, PARITY%, SB%)

IF BAUD% = 19200 THEN
  CMD% = &H0
ELSEIF BAUD% = 9600 THEN
  CMD% = &HE0
ELSEIF BAUD% = 4800 THEN
  CMD% = &HC0
ELSEIF BAUD% = 2400 THEN
  CMD% = &HA0
ELSEIF BAUD% = 1200 THEN
  CMD% = &H80
ELSEIF BAUD% = 600 THEN
  CMD% = &H60
ELSEIF BAUD% = 300 THEN
  CMD% = &H40
ELSEIF BAUD% >= 1 THEN
  CMD% = &H0:
END IF

IF PARITY% = 1 THEN
  CMD% = CMD% + &H8
ELSEIF PARITY% = 2 THEN
  CMD% = CMD% + &H18
END IF

IF SB% = 2 THEN CMD% = CMD% + &H4

IF DB% = 6 THEN
  CMD% = CMD% + &H1
ELSEIF DB% = 7 THEN
  CMD% = CMD% + &H2
ELSEIF DB% = 8 THEN
  CMD% = CMD% + &H3
END IF

COMV%(0) = 0 * 256 + CMD%
COMV%(1) = 0
COMV%(2) = 0
COMV%(3) = PORT%

DEF SEG = VARSEG(COMBIO%(0))
CALL ABSOLUTE(VARPTR(COMBIO%(0)))
DEF SEG

IF COMV%(0) < 0 THEN
  COMINIT% = 1
ELSE
  COMINIT% = 0
END IF

END FUNCTION

SUB COMINITIAL (COMBIO%(), COMV%())

DIM CODE%(50)

CODE%(0) = &H50: REM PUSH AX
CODE%(1) = &H53: REM PUSH BX
CODE%(2) = &H51: REM PUSH CX
CODE%(3) = &H52: REM PUSH DX
CODE%(4) = &H56: REM PUSH SI
CODE%(5) = &H1E: REM PUSH DS
CODE%(6) = &HBE: REM MOV SI, OFFSET REGS
CODE%(7) = &H0
CODE%(8) = &H0
CODE%(9) = &HB8: REM MOV AX,SEGMENT REGS
CODE%(10) = &H0
CODE%(11) = &H0
CODE%(12) = &H8E: REM MOV DS,AX
CODE%(13) = &HD8
CODE%(14) = &H8B: REM MOV AX, SI[0]
CODE%(15) = &H44
CODE%(16) = &H0
CODE%(17) = &H8B: REM MOV BX, SI[2]
CODE%(18) = &H5C
CODE%(19) = &H2
CODE%(20) = &H8B: REM MOV CX, SI[4]
CODE%(21) = &H4C
CODE%(22) = &H4
CODE%(23) = &H8B: REM MOV DX, SI[6]
CODE%(24) = &H54
CODE%(25) = &H6
CODE%(26) = &HCD: REM INT 14H
CODE%(27) = &H14
CODE%(28) = &H89: REM MOV SI[0],AX
CODE%(29) = &H44
CODE%(30) = &H0
CODE%(31) = &H89: REM MOV SI[2], BX
CODE%(32) = &H5C
CODE%(33) = &H2
CODE%(34) = &H89: REM MOV SI[4], CX
CODE%(35) = &H4C
CODE%(36) = &H4
CODE%(37) = &H89: REM MOV SI[6], DX
CODE%(38) = &H54
CODE%(39) = &H6
CODE%(40) = &H1F: REM POP DS
CODE%(41) = &H5E: REM POP SI
CODE%(42) = &H5A: REM POP DX
CODE%(43) = &H59: REM POP CX
CODE%(44) = &H5B: REM POP BX
CODE%(45) = &H58: REM POP AX
CODE%(46) = &HCB: REM RET FAR

DEF SEG = VARSEG(COMBIO%(0))

FOR I% = 0 TO 46
  POKE VARPTR(COMBIO%(0)) + I%, CODE%(I%)
NEXT I%

AA% = VARPTR(COMV%(0))
IF AA% < 0 THEN
A1% = ((AA% + 32767 + 1) \ 256) + 128
A2% = (AA% + 32767 + 1) MOD 256
ELSE
A1% = AA% \ 256
A2% = AA% MOD 256
END IF
POKE VARPTR(COMBIO%(0)) + 7, A2%
POKE VARPTR(COMBIO%(0)) + 8, A1%

AA% = VARSEG(COMV%(0))
IF AA% < 0 THEN
A1% = ((AA% + 32767 + 1) \ 256) + 128
A2% = (AA% + 32767 + 1) MOD 256
ELSE
A1% = AA% \ 256
A2% = AA% MOD 256
END IF
POKE VARPTR(COMBIO%(0)) + 10, A2%
POKE VARPTR(COMBIO%(0)) + 11, A1%

DEF SEG

END SUB

FUNCTION COMPEEK% (COMBIO%(), COMV%(), PORT%)

COMV%(0) = &HC * 256
COMV%(1) = 0
COMV%(2) = 0
COMV%(3) = PORT%

DEF SEG = VARSEG(COMBIO%(0))
CALL ABSOLUTE(VARPTR(COMBIO%(0)))
DEF SEG

COMPEEK% = COMV%(0)

END FUNCTION

FUNCTION COMPURGERXBUF% (COMBIO%(), COMV%(), PORT%)

COMV%(0) = &HA * 256
COMV%(1) = 0
COMV%(2) = 0
COMV%(3) = PORT%

DEF SEG = VARSEG(COMBIO%(0))
CALL ABSOLUTE(VARPTR(COMBIO%(0)))
DEF SEG

COMPURGERXBUF% = 0

END FUNCTION

FUNCTION COMRXCH% (COMBIO%(), COMV%(), PORT%, CH%)

COMV%(0) = 2 * 256
COMV%(1) = 0
COMV%(2) = 0
COMV%(3) = PORT%

DEF SEG = VARSEG(COMBIO%(0))
CALL ABSOLUTE(VARPTR(COMBIO%(0)))
DEF SEG
CH% = COMV%(0) MOD 256

IF COMV%(0) < 0 THEN
  COMRXCH% = 1
ELSE
  COMRXCH% = 0
END IF

END FUNCTION

FUNCTION COMRXOFF% (COMBIO%(), COMV%(), PORT%)

COMV%(0) = &H3D * 256
COMV%(1) = 0
COMV%(2) = 0
COMV%(3) = PORT%

DEF SEG = VARSEG(COMBIO%(0))
CALL ABSOLUTE(VARPTR(COMBIO%(0)))
DEF SEG

COMRXOFF% = 0

END FUNCTION

FUNCTION COMRXON% (COMBIO%(), COMV%(), PORT%)

COMV%(0) = &H3E * 256
COMV%(1) = 0
COMV%(2) = 0
COMV%(3) = PORT%

DEF SEG = VARSEG(COMBIO%(0))
CALL ABSOLUTE(VARPTR(COMBIO%(0)))
DEF SEG

COMRXON% = 0

END FUNCTION

FUNCTION COMRXS% (COMBIO%(), COMV%(), PORT%, STRA$)

STRA$ = ""
DO
  R% = COMRXCH(COMBIO%(), COMV%(), PORT%, C%)
  STRA$ = STRA$ + CHR$(C%)
LOOP WHILE (R% = 0 AND C% <> 13)

COMRXS% = R%

END FUNCTION

FUNCTION COMSETACTIVE% (COMBIO%(), COMV%(), PORT%, ACTIVE%)

COMV%(0) = &H33 * 256 + ACTIVE%
COMV%(1) = 0
COMV%(2) = 0
COMV%(3) = PORT%

DEF SEG = VARSEG(COMBIO%(0))
CALL ABSOLUTE(VARPTR(COMBIO%(0)))
DEF SEG

COMSETACTIVE% = 0

END FUNCTION

FUNCTION COMSETDTR% (COMBIO%(), COMV%(), PORT%)

COMV%(0) = &H6 * 256
COMV%(1) = 0
COMV%(2) = 0
COMV%(3) = PORT%

DEF SEG = VARSEG(COMBIO%(0))
CALL ABSOLUTE(VARPTR(COMBIO%(0)))
DEF SEG

COMSETDTR% = 0

END FUNCTION

FUNCTION COMSETFLOW% (COMBIO%(), COMV%(), PORT%, FLOW%)

COMV%(0) = &HF * 256 + FLOW%
COMV%(1) = 0
COMV%(2) = 0
COMV%(3) = PORT%

DEF SEG = VARSEG(COMBIO%(0))
CALL ABSOLUTE(VARPTR(COMBIO%(0)))
DEF SEG

COMSETFLOW% = 0

END FUNCTION

FUNCTION COMSETMCR% (COMBIO%(), COMV%(), PORT%, MCR%)

COMV%(0) = &H34 * 256 + MCR%
COMV%(1) = 0
COMV%(2) = 0
COMV%(3) = PORT%

DEF SEG = VARSEG(COMBIO%(0))
CALL ABSOLUTE(VARPTR(COMBIO%(0)))
DEF SEG

COMSETMCR% = 0

END FUNCTION

FUNCTION COMSETPORT% (COMBIO%(), COMV%(), PORT%, ADDR%)

COMV%(0) = &H31 * 256
COMV%(1) = ADDR%
COMV%(2) = 0
COMV%(3) = PORT%

DEF SEG = VARSEG(COMBIO%(0))
CALL ABSOLUTE(VARPTR(COMBIO%(0)))
DEF SEG

COMSETPORT% = 0

END FUNCTION

FUNCTION COMSETTIMEOUT% (COMBIO%(), COMV%(), PORT%, TIMEOUT%)

COMV%(0) = &H3F * 256
COMV%(1) = 0
COMV%(2) = TIMEOUT%
COMV%(3) = PORT%

DEF SEG = VARSEG(COMBIO%(0))
CALL ABSOLUTE(VARPTR(COMBIO%(0)))
DEF SEG

COMSETTIMEOUT% = 0

END FUNCTION

FUNCTION COMSETVECTOR% (COMBIO%(), COMV%(), PORT%, ADDR%)

COMV%(0) = &H32 * 256
COMV%(1) = ADDR%
COMV%(2) = 0
COMV%(3) = PORT%

DEF SEG = VARSEG(COMBIO%(0))
CALL ABSOLUTE(VARPTR(COMBIO%(0)))
DEF SEG

COMSETVECTOR% = 0

END FUNCTION

FUNCTION COMSTAT% (COMBIO%(), COMV%(), PORT%)

COMV%(0) = 3 * 256
COMV%(1) = 0
COMV%(2) = 0
COMV%(3) = PORT%

DEF SEG = VARSEG(COMBIO%(0))
CALL ABSOLUTE(VARPTR(COMBIO%(0)))
DEF SEG

COMSTAT% = COMV%(0)

END FUNCTION

FUNCTION COMTXCH% (COMBIO%(), COMV%(), PORT%, CH%)

COMV%(0) = 1 * 256 + CH%
COMV%(1) = 0
COMV%(2) = 0
COMV%(3) = PORT%

DEF SEG = VARSEG(COMBIO%(0))
CALL ABSOLUTE(VARPTR(COMBIO%(0)))
DEF SEG

IF COMV%(0) < 0 THEN
  COMTXCH% = 1
ELSE
  COMTXCH% = 0
END IF

END FUNCTION

FUNCTION COMTXS% (COMBIO%(), COMV%(), PORT%, STRA$)

FOR I% = 1 TO LEN(STRA$)
  R% = COMTXCH(COMBIO%(), COMV%(), PORT%, ASC(MID$(STRA$, I%, 1)))
  IF (R% <> 0) THEN RR% = R%
NEXT I%

COMTXS% = RR%

END FUNCTION

