' $INCLUDE: 'QB.BI'

DECLARE FUNCTION COMGETTIMEOUT% (PORT%)
DECLARE FUNCTION COMRXON% (PORT%)
DECLARE FUNCTION COMSETTIMEOUT% (PORT%, TIMEOUT%)
DECLARE FUNCTION COMRXOFF% (PORT%)
DECLARE FUNCTION COMDETECTPORT% (PORT%)
DECLARE FUNCTION COMGETPORTS% (PORT%)
DECLARE FUNCTION COMGETMCR% (PORT%)
DECLARE FUNCTION COMGETFC% (PORT%)
DECLARE FUNCTION COMGETPARAM% (PORT%)
DECLARE FUNCTION COMGETINFO% (PORT%, BAUD%, DB%, PARITY%, SB%)
DECLARE FUNCTION COMRXS% (PORT%, STRA$)
DECLARE FUNCTION COMBREAK% (PORT%, BRK%)
DECLARE FUNCTION COMTXS% (PORT%, STRA$)
DECLARE FUNCTION COMSETFLOW% (PORT%, FLOW%)
DECLARE FUNCTION COMPEEK% (PORT%)
DECLARE FUNCTION COMPURGERXBUF% (PORT%)
DECLARE FUNCTION COMSETDTR% (PORT%)
DECLARE FUNCTION COMACTIVE% (PORT%)
DECLARE FUNCTION COMINIT% (PORT%, BAUD%, DB%, PARITY%, SB%)
DECLARE FUNCTION COMTXCH% (PORT%, CH%)
DECLARE FUNCTION COMRXCH% (PORT%, CH%)
DECLARE FUNCTION COMSTAT% (PORT%)
DECLARE FUNCTION COMBUFSTAT% (PORT%)
DECLARE FUNCTION COMSETPORT% (PORT%, ADDR%)
DECLARE FUNCTION COMSETVECTOR% (PORT%, ADDR%)
DECLARE FUNCTION COMSETACTIVE% (PORT%, ACTIVE%)
DECLARE FUNCTION COMSETMCR% (PORT%, MCR%)


REM COMBIO% IS AN INTERFACE BETWEEN BASIC PROGRAM AND PCCOM DRIVER
REM COMV% IS PARAMETERS BETREEN BASIC PROGRAM AND PCCOM DRIVER

REM CALL PCCOM DRIVER TO INITIAL ADAPTER

R% = COMSETVECTOR(4, &HD400)
PRINT R%

FOR I% = 4 TO 11
  IF (I% <= 7) THEN
    R1% = COMSETPORT(I%, &HD400)
  ELSE
    R1% = COMSETPORT(I%, &HD440)
  END IF
  R2% = COMINIT(I%, 19200, 8, 0, 1)
  PRINT R1%, R2%
NEXT I%

R% = COMGETINFO(4, BAUD%, DB%, PARITY%, SB%)
PRINT "COM STATUS -- BAUD"; BAUD%; "DATA BITS"; DB%; "PARITY"; PARITY%; "STOP BIT"; SB%

REM THIS IS AN EXAMPLE WHICH TRANSMITS A STRING WITH 10 TIMES

A$ = "PCCOM TEST PROGRAM FOR BASIC" + CHR$(13) + CHR$(10)

PRINT "Begin To Send Data"
FOR I% = 1 TO 5
  R% = COMTXS(4, A$)
  PRINT USING "##"; R%;
NEXT I%

PRINT
C% = COMPEEK(4)
PRINT "Peek Data :"; CHR$(C%)

PRINT
REM LOOP UNTIL RECEIVED ALL DATA IN RECEIVED BUFFER

PRINT "Begin To Receive Data"

R% = COMRXS(4, B$)
PRINT R%, B$

PRINT
DATAIN% = COMBUFSTAT(4)
PRINT "Received"; DATAIN%; "characters"

FOR I% = 1 TO DATAIN%
  R% = COMRXCH(4, C%)
IF (R% = 0) THEN PRINT CHR$(C%);
NEXT I%

FUNCTION COMACTIVE% (PORT%)

DIM reg1 AS RegType
DIM reg2 AS RegType

reg1.ax = &H4 * 256
reg1.bx = 0
reg1.cx = 0
reg1.dx = PORT%

CALL INTERRUPT(&H14, reg1, reg2)

COMACTIVE% = reg2.ax

END FUNCTION

FUNCTION COMBREAK% (PORT%, BRK%)

DIM reg1 AS RegType
DIM reg2 AS RegType

reg1.ax = &H1A * 256 + BRK%
reg1.bx = 0
reg1.cx = 0
reg1.dx = PORT%

CALL INTERRUPT(&H14, reg1, reg2)

COMBREAK% = 0

END FUNCTION

FUNCTION COMBUFSTAT% (PORT%)

DIM reg1 AS RegType
DIM reg2 AS RegType


reg1.ax = &H30 * 256
reg1.bx = 0
reg1.cx = 0
reg1.dx = PORT%

CALL INTERRUPT(&H14, reg1, reg2)

COMBUFSTAT% = reg2.cx

END FUNCTION

FUNCTION COMDETECTPORT% (PORT%)

DIM reg1 AS RegType
DIM reg2 AS RegType


reg1.ax = &H3B * 256
reg1.bx = 0
reg1.cx = 0
reg1.dx = PORT%

CALL INTERRUPT(&H14, reg1, reg2)

IF reg2.ax = &H55AA THEN
   COMDETECTPORT% = 1
ELSE
   COMDETECTPORT% = 0
END IF

END FUNCTION

FUNCTION COMGETFC% (PORT%)

DIM reg1 AS RegType
DIM reg2 AS RegType


reg1.ax = &H37 * 256
reg1.bx = 0
reg1.cx = 0
reg1.dx = PORT%

CALL INTERRUPT(&H14, reg1, reg2)

COMGETFC% = reg2.ax MOD 256

END FUNCTION

FUNCTION COMGETINFO% (PORT%, BAUD%, DB%, PARITY%, SB%)

DIM reg1 AS RegType
DIM reg2 AS RegType


R% = COMGETPARAM(PORT%)
N% = (R% / 32) AND 7
IF N% = 0 THEN
  BAUD% = 19200
ELSEIF N% = 1 THEN
  BAUD% = 38400
ELSEIF N% = 2 THEN
  BAUD% = 300
ELSEIF N% = 3 THEN
  BAUD% = 600
ELSEIF N% = 4 THEN
  BAUD% = 1200
ELSEIF N% = 5 THEN
  BAUD% = 2400
ELSEIF N% = 6 THEN
  BAUD% = 4800
ELSEIF N% = 7 THEN
  BAUD% = 9600
END IF

N% = (R% / 8) AND 3
IF N% = 1 THEN
  PARITY% = 1
ELSEIF N% = 3 THEN
  PARITY% = 2
ELSE
  PARITY% = 0
END IF

N% = (R% / 4) AND 1
SB% = 2 - N%

N% = R% AND 3
IF N% = 0 THEN
  DB% = 5
ELSEIF N% = 1 THEN
  DB% = 6
ELSEIF N% = 2 THEN
  DB% = 7
ELSE
  DB% = 8
END IF

COMGETINFO% = 0

END FUNCTION

FUNCTION COMGETMCR% (PORT%)

DIM reg1 AS RegType
DIM reg2 AS RegType


reg1.ax = &H36 * 256
reg1.bx = 0
reg1.cx = 0
reg1.dx = PORT%

CALL INTERRUPT(&H14, reg1, reg2)

COMGETMCR% = reg2.ax MOD 256

END FUNCTION

FUNCTION COMGETPARAM% (PORT%)

DIM reg1 AS RegType
DIM reg2 AS RegType


reg1.ax = &H35 * 256
reg1.bx = 0
reg1.cx = 0
reg1.dx = PORT%

CALL INTERRUPT(&H14, reg1, reg2)

COMGETPARAM% = reg2.ax MOD 256

END FUNCTION

FUNCTION COMGETPORTS% (PORT%)

DIM reg1 AS RegType
DIM reg2 AS RegType


reg1.ax = &H3A * 256
reg1.bx = 0
reg1.cx = 0
reg1.dx = PORT%

CALL INTERRUPT(&H14, reg1, reg2)

COMGETPORTS% = reg2.ax

END FUNCTION

FUNCTION COMGETTIMEOUT% (PORT%)

DIM reg1 AS RegType
DIM reg2 AS RegType


reg1.ax = &H40 * 256
reg1.bx = 0
reg1.cx = 0
reg1.dx = PORT%

CALL INTERRUPT(&H14, reg1, reg2)

COMGETTIMEOUT% = reg2.dx

END FUNCTION

FUNCTION COMINIT% (PORT%, BAUD%, DB%, PARITY%, SB%)

DIM reg1 AS RegType
DIM reg2 AS RegType


IF BAUD% = 19200 THEN
  CMD% = &H0
ELSEIF BAUD% = 9600 THEN
  CMD% = &HE0
ELSEIF BAUD% = 4800 THEN
  CMD% = &HC0
ELSEIF BAUD% = 2400 THEN
  CMD% = &HA0
ELSEIF BAUD% = 1200 THEN
  CMD% = &H80
ELSEIF BAUD% = 600 THEN
  CMD% = &H60
ELSEIF BAUD% = 300 THEN
  CMD% = &H40
ELSEIF BAUD% >= 1 THEN
  CMD% = &H0:
END IF

IF PARITY% = 1 THEN
  CMD% = CMD% + &H8
ELSEIF PARITY% = 2 THEN
  CMD% = CMD% + &H18
END IF

IF SB% = 2 THEN CMD% = CMD% + &H4

IF DB% = 6 THEN
  CMD% = CMD% + &H1
ELSEIF DB% = 7 THEN
  CMD% = CMD% + &H2
ELSEIF DB% = 8 THEN
  CMD% = CMD% + &H3
END IF

reg1.ax = 0 * 256 + CMD%
reg1.bx = 0
reg1.cx = 0
reg1.dx = PORT%

CALL INTERRUPT(&H14, reg1, reg2)

IF reg2.ax < 0 THEN
  COMINIT% = 1
ELSE
  COMINIT% = 0
END IF

END FUNCTION

FUNCTION COMPEEK% (PORT%)

DIM reg1 AS RegType
DIM reg2 AS RegType


reg1.ax = &HC * 256
reg1.bx = 0
reg1.cx = 0
reg1.dx = PORT%

CALL INTERRUPT(&H14, reg1, reg2)

COMPEEK% = reg2.ax

END FUNCTION

FUNCTION COMPURGERXBUF% (PORT%)

DIM reg1 AS RegType
DIM reg2 AS RegType


reg1.ax = &HA * 256
reg1.bx = 0
reg1.cx = 0
reg1.dx = PORT%

CALL INTERRUPT(&H14, reg1, reg2)

COMPURGERXBUF% = 0

END FUNCTION

FUNCTION COMRXCH% (PORT%, CH%)

DIM reg1 AS RegType
DIM reg2 AS RegType


reg1.ax = 2 * 256
reg1.bx = 0
reg1.cx = 0
reg1.dx = PORT%


CALL INTERRUPT(&H14, reg1, reg2)

CH% = reg2.ax MOD 256

IF reg2.ax < 0 THEN
  COMRXCH% = 1
ELSE
  COMRXCH% = 0
END IF

END FUNCTION

FUNCTION COMRXOFF% (PORT%)

DIM reg1 AS RegType
DIM reg2 AS RegType


reg1.ax = &H3D * 256
reg1.bx = 0
reg1.cx = 0
reg1.dx = PORT%

CALL INTERRUPT(&H14, reg1, reg2)

COMRXOFF% = 0

END FUNCTION

FUNCTION COMRXON% (PORT%)

DIM reg1 AS RegType
DIM reg2 AS RegType


reg1.ax = &H3E * 256
reg1.bx = 0
reg1.cx = 0
reg1.dx = PORT%

CALL INTERRUPT(&H14, reg1, reg2)

COMRXON% = 0

END FUNCTION

FUNCTION COMRXS% (PORT%, STRA$)

DIM reg1 AS RegType
DIM reg2 AS RegType


STRA$ = ""
DO
  R% = COMRXCH(PORT%, C%)
  STRA$ = STRA$ + CHR$(C%)
LOOP WHILE (R% = 0 AND C% <> 13)

COMRXS% = R%

END FUNCTION

FUNCTION COMSETACTIVE% (PORT%, ACTIVE%)

DIM reg1 AS RegType
DIM reg2 AS RegType


reg1.ax = &H33 * 256 + ACTIVE%
reg1.bx = 0
reg1.cx = 0
reg1.dx = PORT%

CALL INTERRUPT(&H14, reg1, reg2)

COMSETACTIVE% = 0

END FUNCTION

FUNCTION COMSETDTR% (PORT%)

DIM reg1 AS RegType
DIM reg2 AS RegType


reg1.ax = &H6 * 256
reg1.bx = 0
reg1.cx = 0
reg1.dx = PORT%

CALL INTERRUPT(&H14, reg1, reg2)

COMSETDTR% = 0

END FUNCTION

FUNCTION COMSETFLOW% (PORT%, FLOW%)

DIM reg1 AS RegType
DIM reg2 AS RegType


reg1.ax = &HF * 256 + FLOW%
reg1.bx = 0
reg1.cx = 0
reg1.dx = PORT%

CALL INTERRUPT(&H14, reg1, reg2)

COMSETFLOW% = 0

END FUNCTION

FUNCTION COMSETMCR% (PORT%, MCR%)

DIM reg1 AS RegType
DIM reg2 AS RegType


reg1.ax = &H34 * 256 + MCR%
reg1.bx = 0
reg1.cx = 0
reg1.dx = PORT%

CALL INTERRUPT(&H14, reg1, reg2)

COMSETMCR% = 0

END FUNCTION

FUNCTION COMSETPORT% (PORT%, ADDR%)

DIM reg1 AS RegType
DIM reg2 AS RegType


reg1.ax = &H31 * 256
reg1.bx = ADDR%
reg1.cx = 0
reg1.dx = PORT%

CALL INTERRUPT(&H14, reg1, reg2)

COMSETPORT% = 0

END FUNCTION

FUNCTION COMSETTIMEOUT% (PORT%, TIMEOUT%)

DIM reg1 AS RegType
DIM reg2 AS RegType


reg1.ax = &H3F * 256
reg1.bx = 0
reg1.cx = TIMEOUT%
reg1.dx = PORT%

CALL INTERRUPT(&H14, reg1, reg2)

COMSETTIMEOUT% = 0

END FUNCTION

FUNCTION COMSETVECTOR% (PORT%, ADDR%)

DIM reg1 AS RegType
DIM reg2 AS RegType


reg1.ax = &H32 * 256
reg1.bx = ADDR%
reg1.cx = 0
reg1.dx = PORT%

CALL INTERRUPT(&H14, reg1, reg2)

COMSETVECTOR% = 0

END FUNCTION

FUNCTION COMSTAT% (PORT%)

DIM reg1 AS RegType
DIM reg2 AS RegType


reg1.ax = 3 * 256
reg1.bx = 0
reg1.cx = 0
reg1.dx = PORT%

CALL INTERRUPT(&H14, reg1, reg2)

COMSTAT% = reg1.ax

END FUNCTION

FUNCTION COMTXCH% (PORT%, CH%)

DIM reg1 AS RegType
DIM reg2 AS RegType


reg1.ax = 1 * 256 + CH%
reg1.bx = 0
reg1.cx = 0
reg1.dx = PORT%

CALL INTERRUPT(&H14, reg1, reg2)

IF reg2.ax < 0 THEN
  COMTXCH% = 1
ELSE
  COMTXCH% = 0
END IF

END FUNCTION

FUNCTION COMTXS% (PORT%, STRA$)

DIM reg1 AS RegType
DIM reg2 AS RegType


FOR I% = 1 TO LEN(STRA$)
  R% = COMTXCH(PORT%, ASC(MID$(STRA$, I%, 1)))
  IF (R% <> 0) THEN RR% = R%
NEXT I%

COMTXS% = RR%

END FUNCTION

